/* C-SLang 2.0. csl_opt.h
   This header provides definitions of options to configure
   C-SLang for your particular platform and other needs.

   In general, you will need to modify these default definitions,
   for which action permission is expressly granted.

   (C) 2003 MacroExpressions.com 

   Version control:
	$Date: 2003/12/20 $
	$Change: 29 $
	$Revision: #6 $
*/

#ifndef CSL_OPT_H
#define CSL_OPT_H

/* ----------- Compile-time options ----------- */
/*Comment the next line out if not using C-SLang debug interface*/
#define CSL_DEBUG 

#define CSL_MAX_FUNC 255 /* Max # of functions in a C-SLang script */


/* ----------- Basic Data types ------------ */
typedef long reg_t; /* This is the type of Accumulator
                    and Index Register. Note that if you
                    make it an unsigned type, the 'negative'
                    flag will never be set
                    */

typedef unsigned char inpvar_t; /* This is the type of InpVar argument
                                in CSLang scripts. It is used in declaring
                                the input buffer for a SVIRM virtual machine
                                */
typedef unsigned char outpvar_t;/* This is the type of OutpVar argument
                                in CSLang scripts. It is used in declaring
                                the outpur buffer for a SVIRM virtual machine
                                */

typedef unsigned short tempvar_t;/* This is the type of TempVar argument
                                in CSLang scripts. It is used in declaring
                                the temporaries buffer for a SVIRM virtual machine
                                */

typedef reg_t outfunc_arg_t;/* This is the type of data argument to "Virtual
                                Physical Output" function 
                                in CSLang scripts. It is used in declaring
                                and defining VPIO function for a SVIRM 
                                virtual machine. It is recommended that this
                                type is at least as wide as all others, or else
                                some data may be lost in argument passing.
                                */



#endif /* CSL_OPT_H */
