/* C-SLang 2.0. csltest.c
    Simple caller of the pre-configured test set.
    (See samplesvirm.c for test configuration.)
    Useful for regression testing.
    
    If an output filename is given on the command line,
    the test output goes there, otherwise to stdout.
    
   (C) 2003 MacroExpressions.com 

   Version control:
	$Date: 2003/12/20 $
	$Change: 30 $
	$Revision: #2 $
*/

#include <stdio.h>
#include <stdlib.h>
#include "cslpubl.h"
#include "sample.h"
extern void test_all(FILE *log); /* Test executor of pre-configured tests */

int main(int argc, char *argv[])
{
    FILE *f=NULL;

    if(argc == 1) {
        f = stdout;
    }
    else {
        f = fopen(argv[1], "w");
        if(f==NULL) {
            perror("Unable to open the log file");
            return EXIT_FAILURE;
        }
    }

    test_all(f);
    fclose(f);
    return EXIT_SUCCESS;
}
