/* C-SLang 2.0. sample1.c
    Simple example in arithmetic. Illustrates:
    - user macros
    - Repeat Load instruction
    - StoreAExt instruction
    - MulDiv instruction
    
   (C) 2003 MacroExpressions.com 

   Version control:
	$Date: 2003/12/30 $
	$Change: 35 $
	$Revision: #2 $
*/

/* Comment out the following definition if your compiler handles
   tentative forward declarations correctly
*/
#define CSL_CONST 

/* For those who likes to live dangerously:
   you may want to try to uncomment the next line
 */
/* #define CSL_FORMAT_VER1 */

#include "csldef.h"
#include "cslpubl.h"
#include "sample.h"

/********************** Sample Script *******************/

/* you can #define macros, e.g., */
#define div256 \
    MulDiv(Literal, 1, 2) \
    MulDiv(Literal, 1, 128)


#ifdef CSL_FORMAT_VER1
StartScript (_arithm)
StartReg
   FuncReg(arithm1)
EndReg
#else
ScriptStart (_arithm)
RegStart(
   RegFunc(arithm1)
)
#endif
Function(arithm1)
    /* Copy 4 bytes in A and store them 
       This is just an illustration of 
       instructions; for real, use MoveI
    */
	Repeat(Literal, 4) LoadA(InpVar, 0)
    Repeat(Literal, 4) StoreAExt(OutpVar, 6) /*in staight order*/
    
	Repeat(Literal, 4) LoadA(InpVar, 0)
    div256 /* illustrates a macro */
    Repeat(Literal, 4) StoreAExt(OutpVar, 0) /*store divided value*/
    

    /* Multiply and Divide numbers */
	LoadA(Literal, 25)
	MulDiv(Literal, 4, 5)
	StoreA(TempVar, 0)
	LoadA(Literal, 250)
	MulDiv(InpVar, 1, 0)
	StoreA(TempVar, 1)

EndFunction
EndScript

unsigned char inp[] = "abcd";
const sample_t arithm_svirmdata = {
    named_item(_arithm),
    {inp, 4},
    8, /*temps*/
    12, /*outputs*/
};


