/* C-SLang 2.0. sample2.c
    Simple example: 1st character occurrence 
    counting in a string. Illustrates:
    - loop arrangement in a separate function
    - conditional increment in a separate function
    
   (C) 2003 MacroExpressions.com 

   Version control:
	$Date: 2004/08/07 $
	$Change: 70 $
	$Revision: #6 $
*/

/* Comment out the following definition if your compiler handles
   tentative forward declarations correctly
*/
//#define CSL_CONST 

#include "csldef.h"
#include "cslpubl.h"
#include "sample.h"


/********************** Sample Script *******************/
ScriptStart (Charcount)
RegStart(
   RegFunc(charcount)
   RegFunc(charhelper)
   RegFunc(increment)
)
/*Count the number of occurences of the first
  character in the input string
*/
Function (charcount)
    ClearX
    StoreX(TempVar, 1) /*counter*/
    Call(charhelper) /*a hand-made loop must be a separate function */
    Move(TempVar, 1, VPIO, 0) /*output the result*/
EndFunction
/*Illustrates a function wrapper for a loop*/
Function (charhelper)
    LoadAI(InpVar, 1) /* InpVar[1+X] loaded */
    Subtract(Literal, 0) /*Check for 0 character*/
    RetZ                 /*return if end*/
    Subtract(InpVar, 0) /*Compare with char*/
    CallZ(increment)     /*Increment if equal*/
    MoveXA               /*Increment index X*/
    Add(Literal, 1)
    MoveAX
    Jump(charhelper) /* repeat */
EndFunction
Function (increment)
    LoadA(TempVar, 1) /* increment TempVar 1 */
    Add(Literal, 1)
    StoreA(TempVar, 1)
EndFunction
EndScript

/*----------------- SVIRM ----------------- */

#include <stdio.h> /*for printf used in sample native functions*/


/* Sample constant array of SLang inputs for SVIRM initialization.
 * Feel free to modify and experiment with it
 */
static inpvar_t myinp[]="oximoron or \0oxy moron?";


/* output function */
static short int myoutputf(unsigned ionum, outfunc_arg_t value)
{
    (void)ionum;
    printf("%u occurrencies\n", value);
    return 0;
}

const sample_t Charcount_svirmdata = {
    named_item(Charcount),
    {myinp, nelem(myinp)},
    8, /*temps*/
    8, /*outputs*/
    NULL,
    myoutputf
};


